<template>
    <scTable ref="table" :apiObj="list.apiObj" :params="searchKey" @selectionChange="selectionChange" row-key="id">
        <el-table-column type="selection" width="50" fixed="left"></el-table-column>
        <el-table-column label="店铺名称" width="200" fixed="left" prop="store_name"></el-table-column>
        <el-table-column label="账户ID" prop="store_id" width="200"></el-table-column>
        <el-table-column label="自动呼叫快递" prop="type" width="150">
            <template #default="scope">
                <div class="status-success" v-if="scope.row.is_auto==1"><sc-status-indicator type="success"></sc-status-indicator> 开启</div>
                <div class="status-danger" v-else><sc-status-indicator type="danger"></sc-status-indicator> 关闭</div>
            </template>
        </el-table-column>
        <el-table-column label="呼叫快递" prop="express_time" width="150">
            <template #default="scope">
                <span v-if="scope.row.express_time>0">{{ scope.row.express_time }}点后</span>
                <span class="status-danger" v-else>实时</span>
            </template>
        </el-table-column>
        <el-table-column label="核销时机" prop="order_end" width="150">
            <template #default="scope">
                <span v-if="scope.row.order_end==1">订单提交后</span>
                <span v-if="scope.row.order_end==2">快递取件后</span>
                <span v-if="scope.row.order_end==3">快递签收后</span>
            </template>
        </el-table-column>
        <el-table-column label="联系人" prop="express_name" width="150">
            <template #default="scope">
                <span v-if="scope.row.express_name">{{ scope.row.express_name }}</span>
                <span class="status-danger" v-else>未设置</span>
            </template>
        </el-table-column>
        <el-table-column label="联系电话" prop="express_mobile" width="150">
            <template #default="scope">
                <span v-if="scope.row.express_mobile">{{ scope.row.express_mobile }}</span>
                <span class="status-danger" v-else>未设置</span>
            </template>
        </el-table-column>
        <el-table-column label="状态" prop="status" width="120" align="center">
            <template #default="scope">
                <div class="status-success" v-if="scope.row.status==1"><sc-status-indicator type="success"></sc-status-indicator> 正常</div>
                <div class="status-danger" v-else><sc-status-indicator type="danger"></sc-status-indicator> 禁用</div>
            </template>
        </el-table-column>
        <el-table-column label="创建时间" prop="create_at" width="180"></el-table-column>
        <el-table-column label="操作" width="220" align="center" fixed="right">
            <template #default="scope">
                <el-button-group>
                    <el-button text type="success" size="small" @click="table_auth(scope.row)">授权地址</el-button>
                    <el-button text type="warning" size="small" @click="table_path(scope.row)">设置Path</el-button>
                    <el-button text type="primary" size="small" @click="table_view(scope.row)">编辑</el-button>
                    <el-button text type="danger" size="small" @click="table_del(scope.row)">删除</el-button>
                </el-button-group>
            </template>
        </el-table-column>
    </scTable>
    <formMain ref="formMain" @success="handleSuccess"></formMain>
    <authMain ref="authMain" @success="handleSuccess"></authMain>
</template>

<script>
import formMain from './form';
import authMain from './auth';
export default {
    components: {
        formMain,authMain
    },
    data(){
        return {
            list: {
                apiObj: this.$API.merStore.list
            },
            dataSelect:[],
            dataSelectFull:[],
            searchKey:{}
        }
    },
    
    methods: {
        table_auth(data){
            this.$nextTick(() => {
                this.$refs.authMain.open("edit").setData(data)
            })
        },
        table_path(data){
            this.$confirm(`【必须】设置小程序全量用户订单按钮以及跳转路径`, '提示', {
                type: 'warning'
            }).then(async ()=>{
                var loading = this.$loading()
                var resp = await this.$API.merStore.auth.post({"id":data.id});
                loading.close();
                if (resp.code == 0) {
                    return this.$message.error(resp.msg);
                }
                this.$message.success(resp.msg);
                this.$emit("success");
            }).catch(()=>{})
        },
        table_view(data){
            this.$nextTick(() => {
                this.$refs.formMain.open("edit").setData(data)
            })
        },
        table_del(data){
            this.$confirm(`删除店铺后，所有有关该店铺的门店、订单等信息都将删除，不可恢复，确定要执行删除吗`, '提示', {
                type: 'warning'
            }).then(async ()=>{
                var loading = this.$loading()
                var resp = await this.$API.merStore.del.post({"id":data.id});
                loading.close();
                if (resp.code == 0) {
                    return this.$message.error(resp.msg);
                }
                this.$message.success(resp.msg);
                this.$emit("success");
            }).catch(()=>{})
        },
        refresh(){
            this.$refs.table.refresh()
        },
        upData(data){
            this.$refs.table.upData(data)
        },
        handleSuccess(){
            this.$refs.table.refresh()
        },
        sortChange(event){
            if (event.order) {
                var data = {
                    "field":event.prop,
                    "order":event.order
                }
                this.$refs.table.upData(data)
            } else {
                this.$refs.table.reload(this.searchKey)
            }
            return ;
        },
        selectionChange(event){
            this.dataSelect = [];
            var arr = [];
            var arrCompany = [];
            event.forEach(function(val,index){
                arr[index] = val.id;
                arrCompany[index] = val;
            });
            this.dataSelectFull = arrCompany;
            this.dataSelect = arr;
            this.$emit("success",this.dataSelect);
            this.$emit("successFull",this.dataSelectFull);
        },
        table_passwd(row){
            this.$nextTick(() => {
                this.$refs.userPasswd.open("edit").setData(row)
            })
        }
    }
}
</script>